source/api/urls.py
from django.urls import path
from .views import product_list_view, product_list_view_v2, \
    product_create_view, product_create_view_v2

app_name = 'api_v1'


urlpatterns = [
    path('products/', product_list_view, name='product_list'),
    path('products/v2/', product_list_view_v2, name='product_list_v2'),
    path('products/create/', product_create_view, name='product_create'),
    path('products/create/v2/', product_create_view_v2, name='product_create_v2')
]

source/main/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),
    path('', include('webapp.urls')),
    path('api/v1/', include('api.urls')),
    path('api/v2/', include('api_v2.urls')),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework'))
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

source/webapp/urls.py
from django.urls import path
from .views import IndexView, ProductView, ProductCreateView, ProductUpdateView, ProductDeleteView, \
    BasketChangeView, BasketView, OrderListView, OrderDetailView, OrderCreateView, OrderUpdateView, \
    OrderDeliverView, OrderCancelView, OrderProductCreateView, OrderProductUpdateView, \
    OrderProductDeleteView

app_name = 'webapp'

urlpatterns = [
    path('', IndexView.as_view(), name='index'),
    path('products/create/', ProductCreateView.as_view(), name='product_create'),
    path('product/<int:pk>/', ProductView.as_view(), name='product_detail'),
    path('product/<int:pk>/update/', ProductUpdateView.as_view(), name='product_update'),
    path('product/<int:pk>/delete/', ProductDeleteView.as_view(), name='product_delete'),

    path('basket/change/', BasketChangeView.as_view(), name='basket_change'),
    path('basket/', BasketView.as_view(), name='basket'),

    path('orders/', OrderListView.as_view(), name='order_list'),
    path('orders/create/', OrderCreateView.as_view(), name='order_create'),
    path('order/<int:pk>/', OrderDetailView.as_view(), name='order_detail'),
    path('order/<int:pk>/update/', OrderUpdateView.as_view(), name='order_update'),
    path('order/<int:pk>/deliver/', OrderDeliverView.as_view(), name='order_deliver'),
    path('order/<int:pk>/cancel/', OrderCancelView.as_view(), name='order_cancel'),

    path('order/<int:pk>/add-product/', OrderProductCreateView.as_view(), name='order_add_product'),
    path('order-product/<int:pk>/update/', OrderProductUpdateView.as_view(), name='order_product_update'),
    path('order-product/<int:pk>/delete/', OrderProductDeleteView.as_view(), name='order_product_delete'),
]

source/webapp/models.py
from django.conf import settings
from django.db import models

CATEGORY_CHOICES = (
    ('other', 'Другое'),
    ('food', 'Еда'),
    ('clothes', 'Одежда'),
    ('household', 'Товары для дома'),
)


class Product(models.Model):
    name = models.CharField(max_length=200, verbose_name='Товар')
    category = models.CharField(max_length=50, choices=CATEGORY_CHOICES, default=CATEGORY_CHOICES[0][0],
                                verbose_name='Категория')
    photo = models.ImageField(upload_to='product_images', null=True, blank=True, verbose_name='Фото')
    price = models.DecimalField(max_digits=10, decimal_places=2, verbose_name='Цена')
    in_order = models.BooleanField(verbose_name='В наличии', default=True)

    def __str__(self):
        return self.name

    class Meta:
        verbose_name = 'Товар'
        verbose_name_plural = 'Товары'
        permissions = [
            ('can_have_piece_of_pizza', 'Может съесть кусочек пиццы'),
        ]


ORDER_STATUS_DELIVERED = 'delivered'
ORDER_STATUS_CANCELED = 'canceled'
ORDER_STATUS_CHOICES = (
    ('new', 'Новый'),
    ('payed', 'Оплачен'),
    ('processing', 'Обработка'),
    (ORDER_STATUS_DELIVERED, 'Доставлен'),
    (ORDER_STATUS_CANCELED, 'Отменён')
)


class Order(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL, null=True, blank=True, on_delete=models.SET_NULL,
                             verbose_name='Пользователь', related_name='orders')
    first_name = models.CharField(max_length=100, verbose_name='Имя', null=True, blank=True)
    last_name = models.CharField(max_length=100, verbose_name='Фамилия', null=True, blank=True)
    email = models.EmailField(max_length=50, verbose_name='Email', null=True, blank=True)
    phone = models.CharField(max_length=20, verbose_name='Телефон')
    products = models.ManyToManyField(Product, through='OrderProduct', through_fields=('order', 'product'),
                                      verbose_name='Товары', related_name='orders')
    status = models.CharField(max_length=20, choices=ORDER_STATUS_CHOICES, default=ORDER_STATUS_CHOICES[0][0],
                              verbose_name='Статус')
    created_at = models.DateTimeField(auto_now_add=True, verbose_name='Дата создания')
    updated_at = models.DateTimeField(auto_now=True, verbose_name='Дата изменения')

    def __str__(self):
        return "{} ({})".format(self.created_at.strftime('%Y-%m-%d %H:%M:%S'), self.get_status_display())

    def get_total(self):
        total = 0
        for order_product in self.order_products.all():
            total += order_product.get_total()
        return total

    class Meta:
        verbose_name = 'Заказ'
        verbose_name_plural = 'Заказы'
        permissions = [('deliver_order', 'Может доставить заказ')]


class OrderProduct(models.Model):
    order = models.ForeignKey(Order, on_delete=models.CASCADE, verbose_name='Заказ', related_name='order_products')
    product = models.ForeignKey(Product, on_delete=models.CASCADE, verbose_name='Товар', related_name='order_products')
    amount = models.DecimalField(max_digits=10, decimal_places=2, verbose_name='Количество')

    def __str__(self):
        return "{} - {}".format(self.product, self.order)

    def get_total(self):
        return self.amount * self.product.price

    class Meta:
        verbose_name = 'Товар в заказе'
        verbose_name_plural = 'Товары в заказах'

source/webapp/views.py
from django.http import HttpResponseRedirect
from django.shortcuts import reverse, redirect, get_object_or_404
from django.urls import reverse_lazy
from django.views import View
from django.views.generic import ListView, DetailView, CreateView, UpdateView, DeleteView
from django.contrib.auth.mixins import PermissionRequiredMixin, LoginRequiredMixin
from django.contrib import messages

from webapp.forms import BasketOrderCreateForm, ManualOrderForm, OrderProductForm, \
    ProductsFormset
from webapp.models import Product, OrderProduct, Order, ORDER_STATUS_DELIVERED, ORDER_STATUS_CANCELED
from webapp.mixins import StatsMixin


class IndexView(StatsMixin, ListView):
    model = Product
    template_name = 'index.html'

    def get_queryset(self):
        return Product.objects.filter(in_order=True)


class ProductView(StatsMixin, DetailView):
    model = Product
    template_name = 'product/detail.html'


class ProductCreateView(PermissionRequiredMixin, StatsMixin, CreateView):
    model = Product
    template_name = 'product/create.html'
    fields = ('name', 'category', 'price', 'photo', 'in_order')
    permission_required = 'webapp.add_product', 'webapp.can_have_piece_of_pizza'
    permission_denied_message = '403 Доступ запрещён!'

    def get_success_url(self):
        return reverse('webapp:product_detail', kwargs={'pk': self.object.pk})


class ProductUpdateView(LoginRequiredMixin, StatsMixin, UpdateView):
    model = Product
    template_name = 'product/update.html'
    fields = ('name', 'category', 'price', 'photo', 'in_order')
    context_object_name = 'product'

    def get_success_url(self):
        return reverse('webapp:product_detail', kwargs={'pk': self.object.pk})


class ProductDeleteView(LoginRequiredMixin, StatsMixin, DeleteView):
    model = Product
    template_name = 'product/delete.html'
    success_url = reverse_lazy('webapp:index')
    context_object_name = 'product'

    def delete(self, request, *args, **kwargs):
        product = self.object = self.get_object()
        product.in_order = False
        product.save()
        return HttpResponseRedirect(self.get_success_url())


class BasketChangeView(StatsMixin, View):
    def get(self, request, *args, **kwargs):
        products = request.session.get('products', [])

        pk = request.GET.get('pk')
        action = request.GET.get('action')
        next_url = request.GET.get('next', reverse('webapp:index'))

        if action == 'add':
            product = get_object_or_404(Product, pk=pk)
            if product.in_order:
                products.append(pk)
        else:
            for product_pk in products:
                if product_pk == pk:
                    products.remove(product_pk)
                    break

        request.session['products'] = products
        request.session['products_count'] = len(products)

        return redirect(next_url)


class BasketView(StatsMixin, CreateView):
    model = Order
    form_class = BasketOrderCreateForm
    template_name = 'product/basket.html'
    success_url = reverse_lazy('webapp:index')

    def get_context_data(self, **kwargs):
        basket, basket_total = self._prepare_basket()
        kwargs['basket'] = basket
        kwargs['basket_total'] = basket_total
        return super().get_context_data(**kwargs)

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs['user'] = self.request.user
        return kwargs

    def form_valid(self, form):
        if self._basket_empty():
            form.add_error(None, 'В корзине отсутствуют товары!')
            return self.form_invalid(form)
        response = super().form_valid(form)
        self._save_order_products()
        self._clean_basket()
        messages.success(self.request, 'Заказ оформлен!')
        return response

    def _prepare_basket(self):
        totals = self._get_totals()
        basket = []
        basket_total = 0
        for pk, qty in totals.items():
            product = Product.objects.get(pk=int(pk))
            total = product.price * qty
            basket_total += total
            basket.append({'product': product, 'qty': qty, 'total': total})
        return basket, basket_total

    def _get_totals(self):
        products = self.request.session.get('products', [])
        totals = {}
        for product_pk in products:
            if product_pk not in totals:
                totals[product_pk] = 0
            totals[product_pk] += 1
        return totals

    def _basket_empty(self):
        products = self.request.session.get('products', [])
        return len(products) == 0

    def _save_order_products(self):
        totals = self._get_totals()
        for pk, qty in totals.items():
            OrderProduct.objects.create(product_id=pk, order=self.object, amount=qty)

    def _clean_basket(self):
        if 'products' in self.request.session:
            self.request.session.pop('products')
        if 'products_count' in self.request.session:
            self.request.session.pop('products_count')


class OrderListView(LoginRequiredMixin, ListView):
    template_name = 'order/list.html'
    context_object_name = 'orders'
    model = Order

    def get_queryset(self):
        if self.request.user.has_perm('webapp.view_order'):
            return Order.objects.all().order_by('-created_at')
        return self.request.user.orders.all().order_by('-created_at')


class OrderDetailView(LoginRequiredMixin, DetailView):
    template_name = 'order/detail.html'
    model = Order

    def get_queryset(self):
        if self.request.user.has_perm('webapp.view_order'):
            return Order.objects.all()
        return self.request.user.orders.all()


class OrderCreateView(PermissionRequiredMixin, CreateView):
    model = Order
    form_class = ManualOrderForm
    template_name = 'order/create.html'
    permission_required = 'webapp.add_order'

    def get_context_data(self, **kwargs):
        if 'formset' not in kwargs:
            kwargs['formset'] = ProductsFormset()
        kwargs['product_list'] = Product.objects.filter(in_order=True)
        return super().get_context_data(**kwargs)

    def post(self, request, *args, **kwargs):
        self.object = None
        form = self.get_form()
        formset = ProductsFormset(data=request.POST)
        if form.is_valid() and formset.is_valid():
            return self.form_valid(form, formset)
        return self.form_invalid(form, formset)

    def form_valid(self, form, formset):
        self.object = form.save()
        formset.instance = self.object
        formset.save()
        return HttpResponseRedirect(self.get_success_url())

    def form_invalid(self, form, formset):
        return self.render_to_response(self.get_context_data(form=form, formset=formset))

    def get_success_url(self):
        return reverse('webapp:order_detail', kwargs={'pk': self.object.pk})


class OrderUpdateView(PermissionRequiredMixin, UpdateView):
    model = Order
    form_class = ManualOrderForm
    template_name = 'order/update.html'
    context_object_name = 'order'
    permission_required = 'webapp.change_order'

    def get_context_data(self, **kwargs):
        if 'formset' not in kwargs:
            kwargs['formset'] = ProductsFormset(instance=self.object)
        return super().get_context_data(**kwargs)

    def post(self, request, *args, **kwargs):
        self.object = self.get_object()
        form = self.get_form()
        formset = ProductsFormset(instance=self.object, data=request.POST)
        if form.is_valid() and formset.is_valid():
            return self.form_valid(form, formset)
        return self.form_invalid(form, formset)

    def form_valid(self, form, formset):
        self.object = form.save()
        formset.save()
        return HttpResponseRedirect(self.get_success_url())

    def form_invalid(self, form, formset):
        return self.render_to_response(self.get_context_data(form=form, formset=formset))

    def get_success_url(self):
        return reverse('webapp:order_detail', kwargs={'pk': self.object.pk})


class OrderDeliverView(PermissionRequiredMixin, View):
    permission_required = 'webapp.deliver_order'

    def get(self, request, *args, **kwargs):
        order = get_object_or_404(Order, pk=kwargs.get('pk'))
        order.status = ORDER_STATUS_DELIVERED
        order.save()
        return redirect('webapp:order_list')


class OrderCancelView(PermissionRequiredMixin, View):
    permission_required = 'webapp.delete_order'

    def get(self, request, *args, **kwargs):
        order = get_object_or_404(Order, pk=kwargs.get('pk'))
        order.status = ORDER_STATUS_CANCELED
        order.save()
        return redirect('webapp:order_list')


class OrderProductCreateView(PermissionRequiredMixin, CreateView):
    model = OrderProduct
    form_class = OrderProductForm
    template_name = 'order_product/create.html'
    permission_required = 'webapp.create_orderproduct'

    def get_context_data(self, **kwargs):
        kwargs['order'] = self.get_order()
        return super().get_context_data(**kwargs)

    def form_valid(self, form):
        form.instance.order = self.get_order()
        return super().form_valid(form)

    def get_order(self):
        return get_object_or_404(Order, pk=self.kwargs.get('pk'))

    def get_success_url(self):
        return reverse('webapp:order_detail', kwargs={'pk': self.object.order.pk})


class OrderProductUpdateView(PermissionRequiredMixin, UpdateView):
    model = OrderProduct
    form_class = OrderProductForm
    context_object_name = 'order_product'
    template_name = 'order_product/update.html'
    permission_required = 'webapp.change_orderproduct'

    def get_success_url(self):
        return reverse('webapp:order_detail', kwargs={'pk': self.object.order.pk})


class OrderProductDeleteView(PermissionRequiredMixin, DeleteView):
    model = OrderProduct
    template_name = 'order_product/delete.html'
    context_object_name = 'order_product'

source/webapp/templates/order/create.html
{% extends 'base.html' %}
{% load staticfiles %}

{% block content %}
    <h1 class="text-center">Добавить заказ</h1>
    <form method="post" action="{% url 'webapp:order_create' %}">
        {% include 'partial/form.html' %}
        <h3 class="text-center my-3">Товары</h3>
        {% include 'order/product_formset.html' %}
        <div class="form-group text-center">
            <button type="submit" class="btn btn-primary">Сохранить</button>
        </div>
    </form>
{% endblock %}

{% block scripts %}
    <script type="application/javascript">
        // Добавлено в качестве примера, как передать переменные из контекста Django в JS.
        // (нужно вывести их в шаблоне внутри js-кода внутри тега <script> так,
        // чтобы после рендера получился валидный код на js со значениями этих переменных.)
        // Последующие скрипты будут иметь доступ к этим переменным после того, как загрузятся.
        let productOptions = {
            {% for product in product_list %}
            {{ product.pk }}: "{{ product.name }}"{% if not forloop.last %}, {% endif %}
            {% endfor %}
        };
    </script>

    <script type="application/javascript" src="{% static "js/product_formset.js" %}"></script>
{% endblock %}

source/webapp/templates/order/detail.html
{% extends 'base.html' %}

{% block menu %}
    {% if perms.webapp.change_order %}
        <li class="nav-item"><a class="nav-link" href="{% url 'webapp:order_update' order.pk %}">Изменить</a></li>
    {% endif %}
    {% if perms.webapp.deliver_order %}
        <li class="nav-item"><a class="nav-link" href="{% url 'webapp:order_deliver' order.pk %}">Доставить</a></li>
    {% endif %}
    {% if perms.webapp.delete_order %}
        <li class="nav-item"><a class="nav-link" href="{% url 'webapp:order_cancel' order.pk %}">Отменить</a></li>
    {% endif %}
{% endblock %}

{% block content %}
    <h1 class="text-center">Заказ от {{ order.created_at|date:'Y-m-d H:i:s' }} ({{ order.get_status_display }})</h1>
    <p>
        Имя:
        {% if order.first_name %}
            {{ order.first_name }}
        {% else %}
            {% if order.user %}
                {{ order.user.first_name }}
            {% endif %}
        {% endif %}
        {% if order.last_name %}
            {{ order.last_name }}
        {% else %}
            {% if order.user %}
                {{ order.user.last_name }}
            {% endif %}
        {% endif %}
    </p>
    <p>
        Email:
        {% if order.email %}
            {{ order.email }}
        {% else %}
            {% if order.user.email %}
                {{ order.user.email }}
            {% endif %}
        {% endif %}
    </p>
    <p>Телефон: {{ order.phone }}</p>
    <h3 class="text-center my-3">Товары в заказе</h3>
    <p class="text-center">
        {% if perms.webapp.add_orderproduct %}
            <a href="{% url "webapp:order_add_product" order.pk %}">Добавить товар</a>
        {% endif %}
    </p>
    <table class="table table-striped">
        <thead>
        <tr>
            <th scope="col">Товар</th>
            <th scope="col">Цена</th>
            <th scope="col">Количество</th>
            <th scope="col">Итого</th>
            <th colspan="2" class="text-center">Действия</th>
        </tr>
        </thead>
        <tbody>
        {% for item in order.order_products.all %}
            <tr>
                <td><a href="{% url 'webapp:product_detail' item.product.pk %}">{{ item.product.name }}</a></td>
                <td>{{ item.product.price }}</td>
                <td>{{ item.amount }}</td>
                <td>{{ item.get_total|floatformat:2 }}</td>
                <td>
                    {% if perms.webapp.change_orderproduct %}
                        <a href="{% url 'webapp:order_product_update' item.pk %}">Редактировать</a>
                    {% endif %}
                </td>
                <td>
                    {% if perms.webapp.delete_orderproduct %}
                        <a href="{% url 'webapp:order_product_delete' item.pk %}">Удалить</a>
                    {% endif %}
                </td>
            </tr>
        {% endfor %}
        </tbody>
        <tfoot>
        <tr>
            <th colspan="3">Итого:</th>
            <td colspan="3">{{ order.get_total|floatformat:2 }}</td>
        </tr>
        </tfoot>
    </table>
{% endblock %}

source/webapp/templates/order/list.html
{% extends 'base.html' %}

{% block content %}
    <h1 class="text-center mb-3">Заказы</h1>
    {% for order in orders %}
        <div class="card mb-3">
            <div class="card-header">
                <p class="card-text text-right">{{ order.created_at|date:'Y-m-d H:i:s' }} ({{ order.get_status_display }})</p>
            </div>
            <div class="card-body">
                <p class="card-text">
                    Имя:
                    {% if order.first_name %}
                        {{ order.first_name }}
                    {% else %}
                        {% if order.user %}
                            {{ order.user.first_name }}
                        {% endif %}
                    {% endif %}
                    {% if order.last_name %}
                        {{ order.last_name }}
                    {% else %}
                        {% if order.user %}
                            {{ order.user.last_name }}
                        {% endif %}
                    {% endif %}
                </p>
                <p class="card-text">
                    Email:
                    {% if order.email %}
                        {{ order.email }}
                    {% else %}
                        {% if order.user.email %}
                            {{ order.user.email }}
                        {% endif %}
                    {% endif %}
                </p>
                <p class="card-text">Телефон: {{ order.phone }}</p>
            </div>
            <div class="card-footer">
                {% if perms.webapp.view_order or request.user == order.user %}
                    <a class="card-link" href="{% url 'webapp:order_detail' order.pk %}">Просмотреть</a>
                {% endif %}
                {% if perms.webapp.change_order %}
                    <a class="card-link" href="{% url 'webapp:order_update' order.pk %}">Изменить</a>
                {% endif %}
                {% if perms.webapp.deliver_order %}
                    <a class="card-link" href="{% url 'webapp:order_deliver' order.pk %}">Доставить</a>
                {% endif %}
                {% if perms.webapp.delete_order %}
                    <a class="card-link" href="{% url 'webapp:order_cancel' order.pk %}">Отменить</a>
                {% endif %}
            </div>
        </div>
    {% endfor %}
{% endblock %}

source/webapp/templates/order/product_formset.html
{{ formset.management_form }}

{% for error in formset.non_form_errors %}
    <p class="text-danger">{{ error }}</p>
{% endfor %}

<div id="product_forms">
    {% for product_form in formset %}
        <div class="form-row" id="order_products-{{ forloop.counter0 }}">
            <div class="form-group col-md-5">
                {% include 'partial/form_field.html' with field=product_form.product %}
            </div>
            <div class="form-group col-md-5">
                {% include 'partial/form_field.html' with field=product_form.amount %}
            </div>
            <div class="form-group col-md-2 text-center">
                <button type="button" class="btn btn-danger mt-md-3" data-id="order_products-{{ forloop.counter0 }}">Удалить товар
                </button>
            </div>
            <div class="d-none">
                {{ product_form.id }}
                {% if formset.can_delete %}{{ product_form.DELETE }}{% endif %}
            </div>
        </div>
    {% endfor %}
</div>

<div class="form-group text-center">
    <button type="button" id="add_product_form" class="btn btn-success">Добавить ещё товар</button>
</div>

source/webapp/templates/order/update.html
{% extends 'base.html' %}
{% load staticfiles %}

{% block content %}
    <h1 class="text-center">Изменить заказ</h1>
    <form method="post" action="{% url 'webapp:order_update' order.pk %}">
        {% include 'partial/form.html' %}
        <h3 class="text-center my-3">Товары</h3>
        {% include 'order/product_formset.html' %}
        <div class="form-group text-center">
            <button type="submit" class="btn btn-primary">Сохранить</button>
        </div>
    </form>
{% endblock %}

{% block scripts %}
    <script type="application/javascript" src="{% static "js/product_formset.js" %}"></script>
{% endblock %}